﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using Pokkt;

public class OfferwallOperations : MonoBehaviour
{
	// exposed properties
	public GameObject ScreenManagerGO = null;
	public Text PointsEarned;
	public Text StatusMessage;
	private PokktConfig pokktConfig;

	// internal states
	private int _totalPointsEarned = 0;

	void Awake()
	{
		// You will need PokktConfig at different method calls
		// it is single place fro all sdk related info
		pokktConfig = new PokktConfig ();

		// set pokkt params
		pokktConfig.SecurityKey = "iJ02lJss0M";
		pokktConfig.ApplicationId = "a2717a45b835b5e9f50284a38d62a74e";
		pokktConfig.IntegrationType = PokktIntegrationType.INTEGRATION_TYPE_ALL;
		pokktConfig.AutoCacheVideo = false;

		PokktManager.InitPokkt();

		// this will be a unique id per user from developer side
		// developer is free to choose any String data point.
		pokktConfig.ThirdPartyUserId = "123456";

		// handle pokkt offerwall events
		PokktManager.Dispatcher.CoinResponseEvent += (string message) =>
		{
			_totalPointsEarned += int.Parse(message);
			
			PointsEarned.text = "Points Earned: " + _totalPointsEarned.ToString();
			StatusMessage.text = "Points earned from last operation: " + message;
		};

		PokktManager.Dispatcher.CoinResponseWithTransIdEvent += (string message) =>
		{
			string[] items = message.Split(new char[] { ',', ' ' }, System.StringSplitOptions.RemoveEmptyEntries);
			string points = items[0];
			string transId = items[1];

			_totalPointsEarned += int.Parse(points);

			PointsEarned.text = "Points Earned: " + _totalPointsEarned.ToString();
			StatusMessage.text = "Points earned from transaction id: " + transId + ", earned points: " + points;
		};

		PokktManager.Dispatcher.CoinResponseFailedEvent += (string message) =>
		{
			StatusMessage.text = message;
		};

		PokktManager.Dispatcher.CampaignAvailabilityEvent += (string message) =>
		{
			StatusMessage.text = message;
		};

		PokktManager.Dispatcher.OfferwallClosedEvent += (string message) =>
		{
			StatusMessage.text = message;
		};
	}

	void Start()
	{
	}
	
	void Update()
	{
		if (Input.GetKeyDown(KeyCode.Escape))
			ScreenManagerGO.GetComponent<ScreenManager>().OpenScreen("CampaignSelectorScreen");
	}
	
	void OnApplicationPause(bool paused)
	{
		if (!paused)
		{
			PokktManager.GetPendingCoins();
			PokktManager.CheckOfferWallCampaign();
		}
	}

	public void GetOfferwallAny()
	{
		pokktConfig.OfferWallAssetValue = "";
		PokktManager.GetCoins(pokktConfig);
	}

	public void GetOfferwallFixed()
	{
		PokktManager.GetCoins(pokktConfig);
	}

	public void GetPendingCoins()
	{
		PokktManager.GetPendingCoins();
	}

	public void SetAssetValue(InputField inputField)
	{
		pokktConfig.OfferWallAssetValue = inputField.text;
	}
	
	public void ExportLog()
	{
		PokktManager.ExportLog();
	}
}
