using System;

namespace Pokkt
{
    public class WindowsPhonePerformer : IPerformer
	{
        public WindowsPhonePerformer()
        {
#if UNITY_WSA
            UnityWindowsExtension.PokktNativeExtension.PokktDispatcher = PokktManager.DispatcherGO();
#endif
        }

        public void NotifyNative(string operation, string param)
		{
#if UNITY_WSA
			UnityWindowsExtension.PokktNativeExtension.NotifyWindowsPhone(operation, param);
#else
			throw new InvalidOperationException("Method not implemented!");
#endif
		}

		public bool IsVideoAvailable()
		{
#if UNITY_WSA
		    return UnityWindowsExtension.PokktNativeExtension.IsVideoAvailableOnWindowsPhone();
#else
			throw new InvalidOperationException("Method not implemented!");
#endif
		}

		public float GetVideoVC()
		{
#if UNITY_WSA
            return UnityWindowsExtension.PokktNativeExtension.GetVideoVcOnWindowsPhone();
#else
			throw new InvalidOperationException("Method not implemented!");
#endif
		}

		public string GetPokktSDKVersion()
		{
#if UNITY_WSA
            return UnityWindowsExtension.PokktNativeExtension.GetPokktSdkVersionOnWindowsPhone();
#else
			throw new InvalidOperationException("Method not implemented!");
#endif
		}
	}
}