using System;

namespace Pokkt
{
	public class PokktConfig
	{
		// essential
		private string _securityKey = "";
		private string _applicationId = "";
		private PokktIntegrationType _integrationType = PokktIntegrationType.INTEGRATION_TYPE_ALL;
		private bool _autoCacheVideo = true;
		private string _thirdPartyUserId = "";
		
		// offer wall specific
		private string _offerWallAssetValue = "";
		private bool _closeOnSuccessFlag = false;
		
		// video campaign specific
		private bool _skipEnabled = false;
		private int _defaultSkipTime = 0;
		private string _customSkipMessage = "";
		private string _screenName = "Default";
		private bool _incentivised = true;
		private bool _backButtonDisabled = false;
		private int _retryDuration = 0;

		// optional
		private string _name;
		private string _age;
		private string _sex;
		private string _mobileNo;
		private string _emailAddress;
		private string _location;
		private string _birthday;
		private string _maritalStatus;
		private string _facebookId;
		private string _twitterHandle;
		private string _education;
		private string _nationality;
		private string _employment;
		private string _maturityRating;

		// analytics
		private string _googleAnalyticsID;
		private string _mixPanelProjectToken;
		private string _flurryApplicationKey;
		private string _selectedAnalyticsType;


		public string SecurityKey
		{
			get { return _securityKey; }

			set 
			{
				_securityKey = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetSecurityKey, value);
			}
		}

		public string ApplicationId
		{
			get { return _applicationId; }

			set
			{
				_applicationId = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetApplicationId, value);
			}
		}

		public PokktIntegrationType IntegrationType
		{
			get { return _integrationType; }

			set
			{
				_integrationType = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetIntegrationType, ((int)value).ToString());
			}
		}

		public bool AutoCacheVideo
		{
			get { return _autoCacheVideo; }

			set
			{
				_autoCacheVideo = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetAutoCaching, (value ? "true" : "false"));
			}
		}

		public string ThirdPartyUserId
		{
			get { return _thirdPartyUserId; }

			set
			{
				_thirdPartyUserId = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetThirdPartyUserId, value);
			}
		}

		public string OfferWallAssetValue
		{
			get { return _offerWallAssetValue; }

			set
			{
				_offerWallAssetValue = value;
				//PokktNativeExtension.PerformOperation(PokktOperations.SetOfferWallAssetValue, value);
			}
		}

		public bool CloseOnSuccessFlag
		{
			get { return _closeOnSuccessFlag; }

			set
			{
				_closeOnSuccessFlag = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetCloseOnSuccessFlag, (value ? "true" : "false"));
			}
		}

		public bool SkipEnabled
		{
			get { return _skipEnabled; }

			set
			{
				_skipEnabled = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetSkipEnabled, (value ? "true" : "false"));
			}
		}

		public int DefaultSkipTime
		{
			get { return _defaultSkipTime; }

			set
			{
				_defaultSkipTime = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetDefaultSkipTime, value.ToString());
			}
		}

		public string CustomSkipMessage
		{
			get { return _customSkipMessage; }

			set
			{
				_customSkipMessage = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetCustomSkipMessage, value);
			}
		}

		public string ScreenName
		{
			get { return _screenName; }

			set
			{
				_screenName = value;
				//PokktNativeExtension.PerformOperation(PokktOperations.SetScreenName, value);
			}
		}

		public bool Incentivised
		{
			get { return _incentivised; }

			set
			{
				_incentivised = value;
				//PokktNativeExtension.PerformOperation(PokktOperations.SetIncentivised, (value ? "true" : "false"));
			}
		}

		public bool BackButtonDisabled
		{
			get { return _backButtonDisabled; }

			set
			{
				_backButtonDisabled = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetBackButtonDisabled, (value ? "true" : "false"));
			}
		}

		public int RetryDuration
		{
			get { return _retryDuration; }

			set
			{
				_retryDuration = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetRetryDuration, value.ToString());
			}
		}
		
		public string Name
		{
			get { return _name; }

			set
			{
				_name = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetName, value);
			}
		}
		
		public string Age
		{
			get { return _age; }

			set
			{
				_age = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetAge, value);
			}
		}
		
		public string Sex
		{
			get { return _sex; }

			set
			{
				_sex = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetSex, value);
			}
		}
		
		public string MobileNo
		{
			get { return _mobileNo; }

			set
			{
				_mobileNo = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetMobileNo, value);
			}
		}
		
		public string EmailAddress
		{
			get { return _emailAddress; }

			set
			{
				_emailAddress = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetEmailAddress, value);
			}
		}
		
		public string Location
		{
			get { return _location; }

			set
			{
				_location = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetLocation, value);
			}
		}
		
		public string Birthday
		{
			get { return _birthday; }

			set
			{
				_birthday = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetBirthday, value);
			}
		}
		
		public string MaritalStatus
		{
			get { return _maritalStatus; }

			set
			{
				_maritalStatus = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetMaritalStatus, value);
			}
		}
		
		public string FacebookId
		{
			get { return _facebookId; }

			set
			{
				_facebookId = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetFacebookId, value);
			}
		}
		
		public string TwitterHandle
		{
			get { return _twitterHandle; }

			set
			{
				_twitterHandle = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetTwitterHandle, value);
			}
		}
		
		public string Education
		{
			get { return _education; }

			set
			{
				_education = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetEducation, value);
			}
		}

		public string Nationality
		{
			get { return _nationality; }

			set
			{
				_nationality = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetNationality, value);
			}
		}

		public string Employment
		{
			get { return _employment; }

			set
			{
				_employment = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetEmployment, value);
			}
		}

		public string MaturityRating
		{
			get { return _maturityRating; }

			set
			{
				_maturityRating = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetMaturityRating, value);
			}
		}
		
		public string GoogleAnalyticsID
		{
			get { return _googleAnalyticsID; }

			set
			{
				_googleAnalyticsID = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetGoogleAnalyticsId, value);
			}
		}

		public string MixPanelProjectToken
		{
			get { return _mixPanelProjectToken; }

			set
			{
				_mixPanelProjectToken = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetMixPanelProjectToken, value);
			}
		}

		public string FlurryApplicationKey
		{
			get { return _flurryApplicationKey; }

			set
			{
				_flurryApplicationKey = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetFlurryApplicationKey, value);
			}
		}

		public string SelectedAnalyticsType
		{
			get { return _selectedAnalyticsType; }

			set
			{
				_selectedAnalyticsType = value;
				PokktNativeExtension.PerformOperation(PokktOperations.SetSelectedAnalyticsType, value);
			}
		}
	}
}