//
//  SuperSonicNetwork.m
//  SampleApp
//
//  Created by Pokkt on 10/26/15.
//  Copyright © 2015 Pokkt. All rights reserved.
//

#import "SuperSonicNetwork.h"
#import "PokktNetworkDelegate.h"
#import <Supersonic/Supersonic.h>
#import <Supersonic/SupersonicConfiguration.h>
#import <Supersonic/SUSupersonicAdsConfiguration.h>
#import "NetworkModel.h"
#import "PokktManager.h"

@implementation SuperSonicNetwork

@synthesize networkName;

static  NSString * userId;
static  NSString * appKey;
static BOOL isInitialized;

- (void)initNetwork:(PokktConfig *)pokktConfig networkModel:(NetworkModel *)customData
presentingViewController:(UIViewController *)viewController
{
    if (isInitialized) {
        return;
    }
    self.pokktConfig = pokktConfig;
    userId =[customData.customData objectForKey:@"userID"];
    appKey = [customData.customData objectForKey:@"appKey"];
    self.network = customData;
    [[Supersonic sharedInstance] setRVDelegate:self];
    [[Supersonic sharedInstance] initRVWithAppKey:appKey withUserId:userId];
    isInitialized = YES;

    NSLog(@"[SuperSonic SDK]SuperSonic Initialised with Timer");
}

- (void)cacheVideo
{
    NSString *str = nil;

    BOOL flag = [[Supersonic sharedInstance] isAdAvailable];
    if (flag)
    {
        [PokktNetworkDelegate didFinishedVideoDownload:self.pokktConfig networkModel:self.network rewardValue:0 downLoadTime:@""];
         str = @"[SuperSonic SDK] SuperSonic video is available to watch";
    }else{
        [PokktNetworkDelegate didFailedVideoDownload:self.pokktConfig networkModel:self.network errorMessage:@"Ad Not Available!!"];
        str = @"[SuperSonic SDK] SuperSonic video is not available right now!!";
    }
    NSLog(@"%@",str);
}

- (void)playVideo
{
    [[Supersonic sharedInstance] showRV];
     NSLog(@"[SuperSonic SDK]Supersonic Video Play");
}

//Fired when callback was successfully made
- (void)supersonicRVInitSuccess{
    NSLog(@"SuperSonic SDK|%s|%s", "DemoRVDelegate", "supersonicRVInitSuccess");
}

- (void)supersonicRVInitFailedWithError:(NSError *)error{
    NSLog(@"SuperSonic SDK|%s|%s|%@", "DemoRVDelegate", "supersonicRVInitFailedWithError", [error description]);
}

- (void)supersonicRVAdAvailabilityChanged:(BOOL)hasAvailableAds{
    if (hasAvailableAds == TRUE)
    {
        NSLog(@"[SuperSonic SDK] SuperSonic Video downloaded");
    }
    else {
        NSLog(@"[SuperSonic SDK] SuperSonic Video Not available");
    }
}

- (void)supersonicRVAdOpened{
    NSLog(@"SuperSonic SDK|%s|%s", "DemoRVDelegate", "supersonicRVAdOpened");
    [PokktNetworkDelegate onVideoDisplayed:self.pokktConfig networkModel:self.network];
}

- (void)supersonicRVAdStarted{
    NSLog(@"SuperSonic SDK|%s|%s", "DemoRVDelegate", "supersonicRVAdStarted");
}

- (void)supersonicRVAdEnded{
    NSLog(@"SuperSonic SDK|%s|%s", "DemoRVDelegate", "supersonicRVAdEnded");
}

- (void)supersonicRVAdClosed{
    NSLog(@"SuperSonic SDK|%s|%s", "DemoRVDelegate", "supersonicRVAdClosed");
    [PokktNetworkDelegate onVideoClosed:self.pokktConfig networkModel:self.network];
}

- (void)supersonicRVAdRewarded:(SupersonicPlacementInfo*)placementInfo{
    NSLog(@"SuperSonic SDK|%s|%s|placementInfo = %@", "DemoRVDelegate", "supersonicRVAdRewarded", placementInfo);
    [PokktNetworkDelegate onVideoCompleted:self.pokktConfig networkModel:self.network];
    [PokktNetworkDelegate onVideoGratified:self.pokktConfig networkModel:self.network rewardPoint:placementInfo.rewardAmount.floatValue];
}

- (void)supersonicRVAdFailedWithError:(NSError *)error{
    NSLog(@"[SuperSonic SDK] SuperSonic Video download failed reason: %@",error.description);
    
}


@end
